import 'package:apexid/apexid.dart';
import 'package:apexid_example/main.dart';
import 'package:flutter/material.dart';

class Router {
  static const String mainRoute = '/';
  static const String apexId = '/apexId';
  static const String apexIdSettings = '/apexId/settings';

  static Route<dynamic> generateRoute(RouteSettings settings) {
    switch (settings.name) {
      case apexId:
        return MaterialPageRoute(
            builder: (_) => ApexIdApp());
      case apexIdSettings:
        return MaterialPageRoute(
            builder: (_) => ApexIdSetting());
      case mainRoute:
        return MaterialPageRoute(
            builder: (_) => MainScreen());
      default:
        return MaterialPageRoute(
            builder: (_) => Scaffold(
                  body: Center(
                      child: Text('No route defined for ${settings.name}')),
                ));
    }
  }

  static namedNavigateTo(BuildContext context, String routeName,
      {bool replacement = false, bool named = true, Object arguments}) {
    if (replacement) {
      Navigator.pushReplacementNamed(context, routeName, arguments: arguments);
    } else {
      Navigator.pushNamed(context, routeName, arguments: arguments);
    }
  }
}

class DataPass {
  final Map<String, dynamic> items;

  DataPass(this.items);

  operator [](String key) => items[key];
}
