import 'dart:convert';

import 'package:apex_flutter_plugin/apex_flutter_plugin.dart';
import 'package:crypto/crypto.dart';
import 'package:flutter/foundation.dart';
import 'package:universal_html/html.dart' as html;

class FingerPrint {
  Future<String> get() async {
    if (kIsWeb) {
      String fingerprint = html.window.navigator.userAgent +
          html.window.navigator.language +
          html.window.navigator.platform +
          html.window.navigator.deviceMemory?.toString();
      return sha256.convert(utf8.encode(fingerprint)).toString();
    } else {
      return sha256
          .convert(utf8.encode(await ApexFlutterPlugin.fingerprint()))
          .toString();
    }
  }
}
