import 'package:flutter/foundation.dart';
import 'package:flutter/material.dart';
import 'package:apexid/screens/login_options_screen.dart';
import 'package:apexid/screens/login_otp_screen.dart';
import 'package:apexid/screens/login_password_screen.dart';
import 'package:apexid/screens/login_screen.dart';
import 'package:apexid/screens/main_screen.dart';
import 'package:apexid/screens/splash_screen.dart';

class ApexIdRouter {
  static const String splashRoute = '/apexId';
  static const String loginRoute = '/apexId/login';
  static const String loginOptionsRoute = '/apexId/login/options';
  static const String loginOtpRoute = '/apexId/login/options/otp';
  static const String loginPasswordRoute = '/apexId/login/options/password';
  static const String mainRoute = '/apexId/login/success';

  static Route<dynamic> generateRoute(RouteSettings settings) {
    switch (settings.name) {
      case splashRoute:
        DataPass dataP = settings.arguments as DataPass;
        return MaterialPageRoute(
            builder: (_) =>
                ApexIdSplashScreen(data: dataP));
      case loginRoute:
        DataPass data = (settings.arguments) as DataPass ;
        return MaterialPageRoute(builder: (_) => ApexIdLoginScreen(data: data));
      case loginOptionsRoute:
        DataPass data = (settings.arguments) as DataPass;
        return MaterialPageRoute(builder: (_) => ApexIdLoginOptionsScreen(data: data));
      case loginOtpRoute:
        DataPass data = (settings.arguments) as DataPass;
        return MaterialPageRoute(builder: (_) => ApexIdLoginOtpScreen(data: data));
      case loginPasswordRoute:
        DataPass data = (settings.arguments) as DataPass;
        return MaterialPageRoute(builder: (_) => ApexIdLoginPasswordScreen(data: data));
      case mainRoute:
        DataPass data = (settings.arguments) as DataPass;
        return MaterialPageRoute(builder: (_) => ApexIdMainScreen(data: data));
      default:
        return MaterialPageRoute(
            builder: (_) => Scaffold(
                  body: Center(
                      child: Text('No route defined for ${settings.name}')),
                ));
    }
  }

  static namedNavigateTo(BuildContext context, String routeName,
      {bool replacement = false, bool named = true, Object arguments}) {
    if (replacement) {
      Navigator.pushReplacementNamed(context, routeName, arguments: arguments);
    } else {
      Navigator.pushNamed(context, routeName, arguments: arguments);
    }
  }
}

class DataPass {
  final Map<String, dynamic> items;

  DataPass(this.items);

  operator [](String key) => items[key];
}
